/*Qfold is a package information tool that provide
the list of packages installe on your Slackware system
Copyright (C) 2008  Giovanni Santostefano

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.*/

#include <QMessageBox>
#include <QStringList>
#include <QTextStream>
#include <QFile>
#include <QFileDialog>


#include <unistd.h>
#include <stdio.h>
#include <iostream>
#include <string>

#include "mainwindow.h"

using namespace std;

MainWindow::MainWindow(QWidget *parent)
: QWidget(parent)
{
	
	//setup the ui interface and bind signals to slots
	ui.setupUi(this);
	connect( ui.pushButton, SIGNAL( clicked() ),
		 this, SLOT( ButtonPressed() ) );
	connect( ui.openButton, SIGNAL( clicked() ),
		 this, SLOT( OpenButtonPressed() ) );
}

MainWindow::~MainWindow()
{
}



void MainWindow::ButtonPressed()
{
	QString str=ui.normaltext->toPlainText();
	QString modstr;
	int count=0;
	int cnt=0;
	bool buf=false;
	QString sub;
	int cols=ui.spinBox->value();
	
	
	if(ui.checkAccents->checkState()==Qt::Checked)
	{
		//turning off accents at the end of words
		str.replace(QString(" "), QString("e' "));
		str.replace(QString(" "), QString("e' "));
		str.replace(QString(" "), QString("E' "));
		str.replace(QString(" "), QString("E' "));
		str.replace(QString(" "), QString("u' "));
		str.replace(QString(" "), QString("U' "));
		str.replace(QString(" "), QString("o' "));
		str.replace(QString(" "), QString("O' "));
		str.replace(QString(" "), QString("i' "));
		str.replace(QString(" "), QString("I' "));
		str.replace(QString(" "), QString("a' "));
		str.replace(QString(" "), QString("A' "));
		str.replace(QString("\t"), QString("    "));
		
		//turning off accents inside a word
		str.replace(QString(""), QString("e"));
		str.replace(QString(""), QString("e"));
		str.replace(QString(""), QString("E"));
		str.replace(QString(""), QString("E"));
		str.replace(QString(""), QString("u"));
		str.replace(QString(""), QString("U"));
		str.replace(QString(""), QString("o"));
		str.replace(QString(""), QString("O"));
		str.replace(QString(""), QString("i"));
		str.replace(QString(""), QString("I"));
		str.replace(QString(""), QString("a"));
		str.replace(QString(""), QString("A"));
	}
	
	
	if(ui.checkWords->checkState()==Qt::Checked)
	{
		for(int i=0; i< str.size(); ++i)
		{
			if(str.data()[i]=='\n' && !buf)
			{
				modstr+=str.data()[i];
				count=0;
				cnt=0;
				buf=false;
				sub.clear();
				continue;
			}
		
			if(str.data()[i]==' ' && !buf)
			{
				modstr+=str.data()[i];
				if(count>=cols){modstr+='\n'; count=0;}
				else ++count;
				continue;
			}
		
			if(str.data()[i]==' ' && buf)
			{
				if((count+cnt)>=cols)
				{
					count=cnt;
					--i; // ;)
					modstr+='\n';
					modstr+=sub;
					cnt=0;
					buf=false;
					sub.clear();
					continue;
				}
				else
				{
					count+=cnt;
					--i; // ;)
					modstr+=sub;
					cnt=0;
					buf=false;
					sub.clear();
					continue;
				}
			}
		
			if(str.data()[i]=='\n' && buf)
			{
				if((count+cnt)>=cols)
				{
					count=cnt;
					--i; // ;)
					modstr+='\n';
					modstr+=sub;
					cnt=0;
					buf=false;
					sub.clear();
					continue;
				}
				else
				{
					count+=cnt;
					--i; // ;)
					modstr+=sub;
					cnt=0;
					buf=false;
					sub.clear();
					continue;
				}
			}
		
		
			buf=true;
			sub+=str.data()[i];
			++cnt;
		
		}
	
		if(!sub.isEmpty())
		{
			if((count+cnt)>=cols)
			{
				modstr+='\n';
				modstr+=sub;
			}
			else
			{
				modstr+=sub;
			}
		}
	}
	else
	{
		for(int i=0; i< str.size(); ++i)
		{
			modstr+=str.data()[i];
			if(count==cols){modstr+='\n'; count=0;}
			else ++count;
			if(str.data()[i]=='\n') count=0;
		}
	}
	
	ui.modtext->setPlainText(modstr);
	
}

void MainWindow::OpenButtonPressed()
{
	QString filename = QFileDialog::getOpenFileName(0,"Open text",".");
	
	//cancel is selected at file choosing dialog
	if(filename.isEmpty()) return;
	
	//file opening and reading the content
	QFile file(filename);
	if(!file.open(QIODevice::ReadOnly))
	{
			//error
		QMessageBox msgBox(this);
		msgBox.setWindowTitle("Qfold Error");
		msgBox.setText( "File opening error!");
		msgBox.setStandardButtons(QMessageBox::Close);
		msgBox.exec();
		return;
	}
		
	ui.normaltext->setPlainText(QTextStream(&file).readAll());
	
	file.close();
}

//#include "mainwindow.moc"
